"""Add Site connectivity check task.

Revision ID: 8a65d0ed588e
Revises: 818d4ffe65df
Create Date: 2024-12-18 14:36:35.886366

"""
from uuid import uuid4

import sqlalchemy as sa
from alembic import op

# revision identifiers, used by Alembic.
revision = '8a65d0ed588e'
down_revision = '818d4ffe65df'
branch_labels = None
depends_on = None

workflow = {
    "name": "task_check_site_connectivity",
    "target": "SYSTEM",
    "description": "Check Site Connectivity",
    "workflow_id": uuid4(),
}


def upgrade() -> None:
    conn = op.get_bind()
    conn.execute(
        sa.text(
            "INSERT INTO workflows VALUES (:workflow_id, :name, :target, :description, now()) ON CONFLICT DO NOTHING"
        ),
        workflow,
    )


def downgrade() -> None:
    conn = op.get_bind()
    conn.execute(sa.text("DELETE FROM workflows WHERE name = :name"), {"name": workflow["name"]})
