"""A VRF product type."""

from orchestrator.domain.base import SubscriptionModel
from orchestrator.types import SubscriptionLifecycle

from gso.products.product_blocks.vrf import VRFBlock, VRFBlockInactive, VRFBlockProvisioning


class VRFInactive(SubscriptionModel, is_base=True):
    """An inactive VRF."""

    vrf: VRFBlockInactive


class VRFProvisioning(VRFInactive, lifecycle=[SubscriptionLifecycle.PROVISIONING]):
    """A provisioning VRF."""

    vrf: VRFBlockProvisioning


class VRF(VRFProvisioning, lifecycle=[SubscriptionLifecycle.ACTIVE]):
    """A VRF that is currently active."""

    vrf: VRFBlock
